EXPEDI - Expedition


A group of cows grabbed a truck and ventured on an expedition deep into the jungle. Being rather poor drivers, the cows unfortunately managed to run over a rock and puncture the truck's fuel tank. The truck now leaks one unit of fuel every unit of distance it travels.

To repair the truck, the cows need to drive to the nearest town (no more than 1,000,000 units distant) down a long, winding road. On this road, between the town and the current location of the truck, there are N (1 <= N <= 10,000) fuel stops where the cows can stop to acquire additional fuel (1..100 units at each stop).

The jungle is a dangerous place for humans and is especially dangerous for cows. Therefore, the cows want to make the minimum possible number of stops for fuel on the way to the town. Fortunately, the capacity of the fuel tank on their truck is so large that there is effectively no limit to the amount of fuel it can hold. The truck is currently L units away from the town and has P units of fuel (1 <= P <= 1,000,000).

Determine the minimum number of stops needed to reach the town, or if the cows cannot reach the town at all.

Input

The first line of the input contains an integer t representing the number of test cases. Then t test cases follow. Each test case has the follwing form:

  • Line 1: A single integer, N
  • Lines 2..N+1: Each line contains two space-separated integers describing a fuel stop: The first integer is the distance from the town to the stop; the second is the amount of fuel available at that stop.
  • Line N+2: Two space-separated integers, L and P

Output

For each test case, output a single integer giving the minimum number of fuel stops necessary to reach the town. If it is not possible to reach the town, output -1.

Example

Input:
1
4
4 4
5 2
11 5
15 10
25 10

Output:
2

Input details

The truck is 25 units away from the town; the truck has 10 units of fuel. Along the road, there are 4 fuel stops at distances 4, 5, 11, and 15 from the town (so these are initially at distances 21, 20, 14, and 10 from the truck). These fuel stops can supply up to 4, 2, 5, and 10 units of fuel, respectively.

Output details

Drive 10 units, stop to acquire 10 more units of fuel, drive 4 more units, stop to acquire 5 more units of fuel, then drive to the town.


hide comments
dkkv0000: 2020-01-22 17:01:51

best problem literally f*** me

vineetjai: 2019-12-03 14:57:03

Use heap and sorting

Last edit: 2019-12-03 14:57:12
wingman__7: 2019-10-06 17:37:22

On the codechef's page this question is tagged with heaps, I really don't find any solution using heaps I solved it using sorting and applying brute force.

harry_shit: 2019-08-04 07:14:22

nice problem

nagadiapreet: 2019-05-15 12:57:03

is L greater than all the distance of stops?

nikita1199: 2019-04-28 07:08:53

nice problem

sherlock11: 2019-02-01 10:40:30

the moment you look at the comments...and bang problem is solved....

be1035016: 2019-01-29 08:00:04

O(N*N) dp working here

cyg_andreih: 2019-01-11 11:56:19

1 ?

ankur314: 2018-12-09 10:18:09

Wonderful Problem!!
Somewhat similar problem on codechef: KILLING ZOMBIES

Last edit: 2018-12-09 10:25:23

Added by:Jimmy
Date:2005-05-03
Time limit:2.307s
Source limit:50000B
Memory limit:1536MB
Cluster: Cube (Intel G860)
Languages:All except: NODEJS PERL6 VB.NET
Resource:US Open International 2005 Gold Division